#if 0
# native:
# need es.getString(var)
# need es.setInt(var, value)
# need es.setString(var, value)
# need es.setFloat(var, value)
# need es.InsertServerCommand(command)
# need es.ServerCommand(command)
# need es.Msg(msg)
# need es.Log(msg)
# need to execute addons.triggerEvent("player_say", {"userid", "2"})
# need to execute:
##   execfile("es_"+name+".py")
##   addons.load(module)
# need to execute the code below to initialize interpreter
#endif

# need a class for direct Server commands
#   call for Valve console command immediate execution
#   call for Valve console command eventual execution
#   call for Valve to Msg
#   call for Valve to Log
class SourceServer:
  def cmd(self, command):
    espy.InsertServerCommand(command)
    return
  def queuecmd(self, command):
    espy.ServerCommand(command)
    return
  def printmsg(self, msg):
    espy.printmsg(msg)
  def log(self, log):
    espy.log(log)
# instantiate Server class
server = SourceServer()

# need a class for ServerVariables
#   calls back into Valve Plugin for lookup
#   calls back into Valve Plugin for set
class SourceServerVariables:
  def __getitem__(self, var):
    return espy.getString(var)
  def __setitem__(self, var, value):
    if (type(value) == int):
      espy.setInt(var, value)
    elif (type(value) == str ):
      espy.setString(var, value)
    elif (type(value) == float):
      espy.setFloat(var, value)
    return
# instantiate ServerVariables class
server_var = SourceServerVariables()

class SourceEventVariables:
  def __getitem__(self, var):
    return espy.getEventInfo(var)
event_var = SourceEventVariables()

# default output function
def output(string):
  print string

# need a class for AddonManager
#   load addon
#   unload addon
#   disable addon
#   enable addon
#   list addons
#   registerForEvent(listenername, eventname, callback)
#   unregisterForEvent(listenername, eventname)
#   triggerEvent(eventname, eventinfo)
class AddonManager:
  def __init__(self):
    self.AddonList = []
    self.EventListeners = {}
  def load(self, addon):
    if (addon not in self.AddonList):
      self.AddonList.append(addon)
      addon.load()
      addon.enable()
      server.log("Loaded:" + addon.Name)
    else:
      server.log("Already loaded:" + addon.Name)
  def unload(self, addon):
    self.AddonList.remove(addon)
    addon.disable()
    addon.unload()
  def disable(self, addon):
    addon.disable()
  def enable(self, addon):
    addon.enable()
  def list(self, outputfunc=output):
    for x in self.AddonList:
      outputfunc("  Name: %s %s\n  Desc: %s\nAuthor: %s\nContact: %s\n\n" % (x.Name, x.Version, x.Description, x.Author, x.Contact))
  # register a listener for a specific event
  def registerForEvent(self, listener, eventname, callback):
    if not self.EventListeners.has_key(eventname):
      self.EventListeners[eventname] = {}
    self.EventListeners[eventname][listener] = callback
  # unregister a listener
  def unregisterForEvent(self, listener, eventname):
    if not self.EventListeners.has_key(eventname):
      return
    if self.EventListeners[eventname].has_key(listener):
      del self.EventListeners[eventname][listener]
  # triggers an event
  def triggerEvent(self, eventname, eventinfo):
    if not self.EventListeners.has_key(eventname):
      return
    for listener in self.EventListeners[eventname]:
      if not listener.disabled:
        self.EventListeners[eventname][listener](eventinfo)
# instantiate AddonManager
addons = AddonManager()

# need a base class for plugins
class Addon:
   Name = "(Unspecified)"
   Version = "0.0"
   Description = "(Unspecified)"
   Help = "(Unspecified)"
   Author = "(Unspecified)"
   Contact = "http://mattie.info/cs/forums"
   MinPyVersion = "0.0.0"
   disabled = True
   
   def load(self):
    return
   def unload(self):
    return
   def disable(self):
    self.disabled = True
    return
   def enable(self):
    self.disabled = False
    return


 
